<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Commanders: D:/Mes documents/Trusty/Arduino/Libraries/Commanders/src/Commander.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Commanders
   </div>
   <div id="projectbrief">Arduino buttons/bus library</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('Commander_8cpp_source.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">Commander.cpp</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*************************************************************</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">project: &lt;Commanders&gt;</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">author: &lt;Thierry PARIS&gt;</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">description: &lt;Base Commander&gt;</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">*************************************************************/</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;</div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="Commanders_8h.html">Commanders.h</a>&gt;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<a class="code" href="classCommander.html">Commander</a> *Commander::pFirstCommander = 0;</div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;</div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#ifdef COMMANDERS_DEBUG_MODE</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#define CHECK(val, text)    CheckIndex(val, F(text))</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#else</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#define CHECK(val, text)</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="keywordtype">void</span> Commander::AddCommander(<a class="code" href="classCommander.html">Commander</a> *inCommander)</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;{</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    <span class="keywordflow">if</span> (Commander::pFirstCommander == NULL)</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    {</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;        Commander::pFirstCommander = inCommander;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;        <span class="keywordflow">return</span>;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    }</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <a class="code" href="classCommander.html">Commander</a> *pCurr = Commander::pFirstCommander;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keywordflow">while</span> (pCurr-&gt;pNextCommander != NULL)</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;        pCurr = pCurr-&gt;pNextCommander;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    pCurr-&gt;pNextCommander = inCommander;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;}</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno"><a class="line" href="classCommander.html#aa11f6874d5b0faad6867415fe20ee96d">   33</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classCommander.html#aa11f6874d5b0faad6867415fe20ee96d">Commander::BeforeFirstLoops</a>()</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;{</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <a class="code" href="classCommander.html">Commander</a> *pCurr = Commander::pFirstCommander;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keywordflow">while</span> (pCurr != NULL)</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    {</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        pCurr-&gt;<a class="code" href="classCommander.html#a07837869d9f0d6950cd8c40dacc7e05f">beforeFirstLoop</a>();</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        pCurr = pCurr-&gt;pNextCommander;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    }</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;}</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div><div class="line"><a name="l00044"></a><span class="lineno"><a class="line" href="classCommander.html#add75d0185fe8f8fc0c9a92a02f3663c8">   44</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classCommander.html#add75d0185fe8f8fc0c9a92a02f3663c8">Commander::CommanderPriorityLoops</a>()</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;{</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <a class="code" href="classCommander.html">Commander</a> *pCurr = Commander::pFirstCommander;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keywordflow">while</span> (pCurr != NULL)</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    {</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        pCurr-&gt;<a class="code" href="classCommander.html#ade3914b5c62cd08a4e97050bc5314734">PriorityLoop</a>();</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        pCurr = pCurr-&gt;pNextCommander;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    }</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;}</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div><div class="line"><a name="l00055"></a><span class="lineno"><a class="line" href="classCommander.html#a10c7c5ee5db3da8acf2b7c8bfd5e3067">   55</a></span>&#160;<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classCommander.html#a10c7c5ee5db3da8acf2b7c8bfd5e3067">Commander::loops</a>()</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;{</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <a class="code" href="classCommander.html">Commander</a> *pCurr = Commander::pFirstCommander;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keywordflow">while</span> (pCurr != NULL)</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    {</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        <a class="code" href="classCommander.html#add75d0185fe8f8fc0c9a92a02f3663c8">Commander::CommanderPriorityLoops</a>();</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> ret = pCurr-&gt;<a class="code" href="classCommander.html#ad071adf2b8c272269394c2c66bf46f00">loop</a>();</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        <span class="keywordflow">if</span> (ret != <a class="code" href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a>)</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;            <span class="keywordflow">return</span> ret;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        pCurr = pCurr-&gt;pNextCommander;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    }</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a>;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;}</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="preprocessor">#ifdef COMMANDERS_PRINT_COMMANDERS</span></div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="keywordtype">void</span> Commander::printCommanders()</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;{</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    Serial.println(F(<span class="stringliteral">&quot;********* Commanders List&quot;</span>));</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    <a class="code" href="classCommander.html">Commander</a> *pCurr = Commander::pFirstCommander;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <span class="keywordflow">while</span> (pCurr != NULL)</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    {</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;        pCurr-&gt;printCommander();</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        pCurr = pCurr-&gt;pNextCommander;</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    }</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    Serial.println(F(<span class="stringliteral">&quot;********* End of List&quot;</span>));</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;}</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="Events_8h_html_a48ad4dd16b8e22f2c8bc92b154479e92"><div class="ttname"><a href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a></div><div class="ttdeci">#define UNDEFINED_ID</div><div class="ttdef"><b>Definition:</b> <a href="Events_8h_source.html#l00038">Events.h:38</a></div></div>
<div class="ttc" id="classCommander_html_ad071adf2b8c272269394c2c66bf46f00"><div class="ttname"><a href="classCommander.html#ad071adf2b8c272269394c2c66bf46f00">Commander::loop</a></div><div class="ttdeci">virtual unsigned long loop()</div><div class="ttdef"><b>Definition:</b> <a href="Commander_8hpp_source.html#l00044">Commander.hpp:44</a></div></div>
<div class="ttc" id="classCommander_html_a10c7c5ee5db3da8acf2b7c8bfd5e3067"><div class="ttname"><a href="classCommander.html#a10c7c5ee5db3da8acf2b7c8bfd5e3067">Commander::loops</a></div><div class="ttdeci">static unsigned long loops()</div><div class="ttdef"><b>Definition:</b> <a href="Commander_8cpp_source.html#l00055">Commander.cpp:55</a></div></div>
<div class="ttc" id="classCommander_html_ade3914b5c62cd08a4e97050bc5314734"><div class="ttname"><a href="classCommander.html#ade3914b5c62cd08a4e97050bc5314734">Commander::PriorityLoop</a></div><div class="ttdeci">virtual void PriorityLoop()</div><div class="ttdef"><b>Definition:</b> <a href="Commander_8hpp_source.html#l00037">Commander.hpp:37</a></div></div>
<div class="ttc" id="classCommander_html_add75d0185fe8f8fc0c9a92a02f3663c8"><div class="ttname"><a href="classCommander.html#add75d0185fe8f8fc0c9a92a02f3663c8">Commander::CommanderPriorityLoops</a></div><div class="ttdeci">static void CommanderPriorityLoops()</div><div class="ttdef"><b>Definition:</b> <a href="Commander_8cpp_source.html#l00044">Commander.cpp:44</a></div></div>
<div class="ttc" id="classCommander_html_a07837869d9f0d6950cd8c40dacc7e05f"><div class="ttname"><a href="classCommander.html#a07837869d9f0d6950cd8c40dacc7e05f">Commander::beforeFirstLoop</a></div><div class="ttdeci">virtual void beforeFirstLoop()</div><div class="ttdef"><b>Definition:</b> <a href="Commander_8hpp_source.html#l00040">Commander.hpp:40</a></div></div>
<div class="ttc" id="classCommander_html_aa11f6874d5b0faad6867415fe20ee96d"><div class="ttname"><a href="classCommander.html#aa11f6874d5b0faad6867415fe20ee96d">Commander::BeforeFirstLoops</a></div><div class="ttdeci">static void BeforeFirstLoops()</div><div class="ttdef"><b>Definition:</b> <a href="Commander_8cpp_source.html#l00033">Commander.cpp:33</a></div></div>
<div class="ttc" id="classCommander_html"><div class="ttname"><a href="classCommander.html">Commander</a></div><div class="ttdef"><b>Definition:</b> <a href="Commander_8hpp_source.html#l00023">Commander.hpp:23</a></div></div>
<div class="ttc" id="Commanders_8h_html"><div class="ttname"><a href="Commanders_8h.html">Commanders.h</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_d41d8cd98f00b204e9800998ecf8427e.html">src</a></li><li class="navelem"><b>Commander.cpp</b></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:55:02 for Commanders &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
